#! /usr/bin/perl

print "xtract tries to extract your myTemp Log Memos \n";
if ($#ARGV ne -1) {
	print "from the MemoDB.pdb automagically and put each to \n";
	print "a file. \n\n";
	print "xtract reads your pdb-file from <STDIN> and looks \n";
	print "for the Sequence \"^.Temperaturelog\\d\\d:\\d\\d:\\d\\d\", \n";
	print "which marks the beginning of a myTemp Log Memo, \n";
	print "in your MemoDB.pdb file.\n\n";
	print "USAGE: xtract < <MemoDB.pdb>, where <MemoDB.pdb> is \n";
	print "the name of your Memo database file. \n";
	print "(usually \"MemoDB.pdb\" :-) )\n\n";
	print "I use the following sequence in gnuplot to plot my diagrams: \n";
	print "set xdata time \n";
	print "set timefmt \"\%H:\%M:\%S\" \n";
	print "plot 'tempxx:xx:xx' using 1:2 with lines \n\n";
	exit 0;
} else {
	print "xtract -h for usage information \n";
}
print "\n01.03.2001 Christof Klaiber <christof.klaiber\@gmx.de> \n\n";

while (<STDIN>) {
	$memodb .= $_;
}

@memos = split(/\000/, $memodb);

$memonum = 1;

foreach $memo (@memos) {
	if ($memo =~ /^.myTempLog(\d\d:\d\d:\d\d)....\n/) {
		@lines = split(/\n/, $memo);
		
		shift @lines, "\n";
								
		foreach $line (@lines) {
			@cells = split(/\s/, $line);
			$sensors{$cells[1]} .= join("\t", $cells[0], $cells[2]);
			$sensors{$cells[1]} .= "\n";
		}
		
		foreach $sensor (sort keys %sensors) {
			open(OUTHANDLE, "> temp$1.$sensor") or die "can't open temp$1.$sensor";
			print "print Output of myTemp Memo# $memonum Sensor $sensor to file temp$1.$sensor\n";
			print OUTHANDLE "$sensors{$sensor}";
		}
		$memonum++;
	}
}
